<template>
  <div>
    <v-card-title v-if="success" class="mt-12 justify-center flex-column">
      <v-icon>mdi-account-check</v-icon>

      <div>Этап регистрации завершен!</div>
    </v-card-title>

    <div v-else class="mx-auto mt-12 max-width-600">
      <v-card-title class="justify-center">
        {{ $t('main-words.registration') }}
      </v-card-title>

      <v-form ref="form" lazy-validation @submit.prevent="submit">
        <v-container class="text-center">
          <v-text-field
            v-model="form.email"
            :rules="[rules.required, rules.email]"
            :label="$t('main-words.email')"
            solo
            required
          />

          <v-text-field
            v-model="form.password"
            :rules="[rules.required, rules.password]"
            :label="$t('main-words.password')"
            type="password"
            solo
            required
          />

          <v-btn :loading="loading" color="deep-orange" type="submit" dark>
            {{ $t('main-words.sign-up') }}
          </v-btn>
        </v-container>
      </v-form>
    </div>

    <v-divider class="my-4" />

    <div>
      <div><b class="d-block">User Secret "r":</b> {{ oprfSk }}</div>
      <div><b class="d-block">Password hash:</b> {{ hash }}</div>
      <div><b class="d-block">Password hash point:</b> {{ point }}</div>
      <div><b class="d-block">Masked point "m":</b> {{ maskPoint }}</div>
    </div>

    <v-divider class="my-4" />

    <div>
      <div><b class="d-block">Session id:</b> {{ authId }}</div>

      <div>
        <b class="d-block">Masked salt point "m":</b> {{ maskSaltPoint }}
      </div>
      <div><b class="d-block">Server OPRF-PK:</b> {{ serverOprfPk }}</div>
      <div><b class="d-block">Server DF-PK:</b> {{ serverPk }}</div>
    </div>

    <v-divider class="my-4" />

    <div>
      <div><b class="d-block">Cipher key:</b> {{ cipherKey }}</div>
      <div><b class="d-block">Cipher:</b> {{ cipher }}</div>
      <div><b class="d-block">User DF-PK:</b> {{ pk }}</div>
    </div>

    <v-divider class="my-4" />
  </div>
</template>

<script>
  import { sendMixin } from '@/mixins/send'

  import {
    emailRuleMixin,
    passwordRuleMixin,
    requiredRuleMixin,
  } from '@/mixins/validation'

  import { RegisterService } from '@/services/RegisterService'
  import { OprfService } from '@/services/OprfService'

  export default {
    name: 'Register',
    mixins: [sendMixin, requiredRuleMixin, emailRuleMixin, passwordRuleMixin],
    data: () => ({
      form: {
        email: '',
        password: '',
      },
      success: false,
      oprfSk: '',
      hash: '',
      point: '',
      maskPoint: '',
      maskSaltPoint: '',
      serverOprfPk: '',
      serverPk: '',

      authId: '',
      cipherKey: '',
      cipher: '',
      pk: '',
    }),
    computed: {
      url() {
        return RegisterService.URL
      },
    },
    methods: {
      async submit() {
        if (!this.$refs.form.validate() || this.loading) return

        await this.registerStart()
      },

      getOprfSk() {
        return new Uint8Array(
          Object.values(JSON.parse(localStorage.getItem('oprfSk')))
        )
      },

      setOprfSk(val) {
        localStorage.setItem('oprfSk', val ? JSON.stringify(val) : val)
      },

      setAuthId(val) {
        localStorage.setItem('authId', val)
      },

      async registerStart() {
        const {
          email,
          challenge,
          hash,
          point,
          oprfSk,
        } = await RegisterService.start(this.form)

        this.oprfSk = oprfSk

        this.hash = hash

        this.point = point

        this.maskPoint = OprfService.decodePoint(challenge)

        this.setOprfSk(oprfSk)

        const params = { email, challenge }

        try {
          const res = await this.sendData(this.url, 'post', params)

          await this.registerFinish(res)
        } catch (e) {
          console.log(e)
        }
      },

      async registerFinish(res) {
        this.authId = res.authId

        this.maskSaltPoint = OprfService.decodePoint(res.challenge)

        this.serverOprfPk = OprfService.decodePoint(res.oprfPk)

        this.serverPk = OprfService.decodePoint(res.pk)

        this.setAuthId(res.authId)

        // eslint-disable-next-line no-unused-vars
        const { key, nonce, ciphertext, pk, sk } = await RegisterService.finish(
          this.form.password,
          this.getOprfSk(),
          res.challenge,
          res.oprfPk,
          res.pk
        )

        this.cipherKey = key
        this.cipher = ciphertext
        this.pk = pk

        const params = {
          email: this.form.email,
          pk: OprfService.encodePoint(pk),
          envelope: JSON.stringify({ ciphertext, nonce }),
        }

        try {
          const success = await this.sendData(
            `${this.url}/${res.authId}`,
            'put',
            params
          )

          success ? (this.success = true) : this.setOprfSk('')
        } catch (e) {
          console.log(e)
        }
      },
    },
  }
</script>

<style scoped></style>
